#!/usr/bin/perl
use strict;
use warnings;

my $infile = "test.gtf";
#my $infile = "../Ciona_intestinalis.KH.79.gtf";
#my $infile = "$ARGV[0]";

open(GTF, $infile) or die ("Cannot find $infile\n");
my @gitLines = <GTF>;
close GTF;

my $ref_recs = &protGeneLocationPicer(\@gitLines);
my @recs = @$ref_recs;
my $countA = 0;
print "#\tprotID\tscaffold\tStart\tEnd\n";
foreach my $ele (@recs) {
  $countA++;
  print "$countA.\t$ele->[0]\t$ele->[1]\t$ele->[2]\t$ele->[3]\n";
}
  exit;


exit;

sub protGeneLocationPicer {
  my ($ref_gtfLinesSR) = @_;
  my @gtfLinesSR = @$ref_gtfLinesSR;

  my %recsSR = ();
  my $count = 0;
  my $scf = "";
  my $scfPrev = "";
  my $protID = "";
  my $protIDprev = "";
  my $flag = 0;
  my @nums = ();
  foreach my $line (@gtfLinesSR) {

    next if $line =~ /^#/;
    next if $line =~ /^$/;
    
    $count++;
    #last if $count == 101;
    chomp($line);

    next unless $line =~ /protein_id/;
#    next unless $line =~ /proteinId/;
#    next unless $line =~ /\tgene\t/;
#    next unless $line =~ /\tmRNA\t/;
  
#    unless ($line =~ /^(.*?)	.*?	.*?	(\d+)	(\d+)	.*protein_id "(\w+)";$/){
    unless ($line =~ /^(.*?)	.*?	.*?	(\d+)	(\d+)	.*protein_id "(\w+)";/){
#    unless ($line =~ /^(.*?)	.*?	.*?	(\d+)	(\d+)	.*protein_id "([^"]+)";/){
#    unless ($line =~ /^(.*?)	.*?	.*?	(\d+)	(\d+)	.*ID=([^\;]+);/){
#    unless ($line =~ /^(.*?)	.*?	.*?	(\d+)	(\d+)	.*proteinId ([^\;]+);/){
      print "Check the structure of line (# of colums and tabs, etc).\n";
      print "\n$line\n\n";
      print "Stopped.\n";
      exit;
    }
    #else {
    #  print "Readed.\n";
    #  exit;
    #}
    my $scf  = $1;
    my $num1 = $2;
    my $num2 = $3;
    $protID  = $4;
  
    #print "$count.$sca\t";
    
    if($flag == 0){
      push(@nums, $num1, $num2);
      $flag = 1;
      $protIDprev = $protID; 
      $scfPrev = $scf;
  
      next;
    }
  
    if($protID eq $protIDprev){
      push(@nums, $num1, $num2);
    } else {
      my @sortedNums = sort {$a <=> $b} @nums;
      $recsSR{$protIDprev} = [$scfPrev, \@sortedNums];
  
      @nums = ();
      $protIDprev = $protID; 
      $scfPrev = $scf;
      push(@nums, $num1, $num2);
    }
  
  }
  my @sortedNums = sort {$a <=> $b} @nums;
  $recsSR{$protIDprev} = [$scfPrev, \@sortedNums];

  my @sortTEMP = ();
  foreach my $ele (keys %recsSR) {
    my @numsA = @{$recsSR{$ele}->[1]};
    my $firstEle = shift(@numsA);
    my $lastEle  = pop(@numsA);
    #print "$ele, $recsSR{$ele}->[0], $firstEle, $lastEle\n";
    push(@sortTEMP, [$ele, $recsSR{$ele}->[0], $firstEle, $lastEle]);
  }
  #exit;
  
  my @sorted = sort{$a->[1] cmp $b->[1] or $a->[2] <=> $b->[2]}@sortTEMP;
  #my @sorted = sort{$b->[1] cmp $a->[1] or $b->[2] <=> $a->[2]}@sortTEMP;
  
  return(\@sorted);
}